"use strict";
exports.__esModule = true;
var defaults = {};
var NgBootstrapPluginClass = /** @class */ (function () {
    function NgBootstrapPluginClass(opts) {
        if (opts === void 0) { opts = defaults; }
        this.opts = opts;
        this.test = /app.browser.module.ts/;
    }
    NgBootstrapPluginClass.prototype.onTypescriptTransform = function (file) {
        if (this.opts.enabled && this.test.test(file.absPath) && file.context.bundle.name === 'app') {
            file.contents = file.contents.replace(/^.*platformBrowserDynamic.*/gm, '');
            file.contents =
                "\n        import { platformBrowser } from '@angular/platform-browser'\n        import { AppModuleNgFactory } from './.aot/src/browser/app.module.ngfactory.js'\n        platformBrowser().bootstrapModuleFactory(AppModuleNgFactory)\n        " + file.contents;
        }
    };
    return NgBootstrapPluginClass;
}());
exports.NgBootstrapPluginClass = NgBootstrapPluginClass;
exports.NgBootstrapPlugin = function (options) {
    return new NgBootstrapPluginClass(options);
};
