import { Plugin, File } from 'fuse-box'

const defaults: NgBootstrapPluginOptions = {
}

export interface NgBootstrapPluginOptions {
  enabled?: boolean
}

export class NgBootstrapPluginClass implements Plugin {
  constructor(public opts: NgBootstrapPluginOptions = defaults) { }
  public test = /app.browser.module.ts/
  
  onTypescriptTransform(file: File) {
    if (this.opts.enabled && this.test.test(file.absPath) && file.context.bundle.name === 'app') {
      file.contents = file.contents.replace(/^.*platformBrowserDynamic.*/gm, '')
      file.contents = 
        `
        import { platformBrowser } from '@angular/platform-browser'
        import { AppModuleNgFactory } from './.aot/src/browser/app.module.ngfactory.js'
        platformBrowser().bootstrapModuleFactory(AppModuleNgFactory)
        ${file.contents}`
    }
  }
}

export const NgBootstrapPlugin = (options?: NgBootstrapPluginOptions) =>
  new NgBootstrapPluginClass(options);
