"use strict";
exports.__esModule = true;
var build_optimizer_1 = require("@angular-devkit/build-optimizer");
var defaults = {};
var NgOptimizerPluginClass = /** @class */ (function () {
    function NgOptimizerPluginClass(opts) {
        if (opts === void 0) { opts = defaults; }
        this.opts = opts;
        this.test = /.js/;
    }
    NgOptimizerPluginClass.prototype.transform = function (file) {
        if (!this.opts.enabled)
            return;
        var transpiledContent = build_optimizer_1.buildOptimizer({
            content: file.contents,
            isSideEffectFree: true
        }).content;
        if (transpiledContent) {
            file.contents = transpiledContent;
        }
    };
    return NgOptimizerPluginClass;
}());
exports.NgOptimizerPluginClass = NgOptimizerPluginClass;
exports.NgOptimizerPlugin = function (options) {
    return new NgOptimizerPluginClass(options);
};
