"use strict";
exports.__esModule = true;
var defaults = {};
exports.NG_POLY_BASE = [
    'core-js/es7/reflect'
];
exports.NG_POLY_SERVER = exports.NG_POLY_BASE.concat([
    'zone.js/dist/zone-node',
    'zone.js/dist/long-stack-trace-zone'
]);
exports.NG_POLY_BROWSER = exports.NG_POLY_BASE.concat([
    'zone.js/dist/zone'
]);
exports.NG_POLY_BROWSER_IE_ANIMATIONS = [
    'web-animations-js'
];
exports.NG_POLY_BROWSER_IE = [
    'core-js/es6/symbol',
    'core-js/es6/object',
    'core-js/es6/function',
    'core-js/es6/parse-int',
    'core-js/es6/parse-float',
    'core-js/es6/number',
    'core-js/es6/math',
    'core-js/es6/string',
    'core-js/es6/date',
    'core-js/es6/array',
    'core-js/es6/regexp',
    'core-js/es6/map',
    'core-js/es6/weak-map',
    'core-js/es6/set'
];
var prepForTransform = function (deps) {
    return deps.map(function (dep) {
        return "import '" + dep + "'";
    }).join('\n');
};
var NgPolyfillPluginClass = /** @class */ (function () {
    function NgPolyfillPluginClass(opts) {
        if (opts === void 0) { opts = defaults; }
        this.opts = opts;
        this.test = this.opts.fileTest &&
            new RegExp(this.opts.fileTest) || /(app.browser.module.ts)/;
    }
    NgPolyfillPluginClass.prototype.onTypescriptTransform = function (file) {
        if (!this.test.test(file.relativePath))
            return;
        file.contents = prepForTransform(this.buildSet()) + "\n" + file.contents;
    };
    NgPolyfillPluginClass.prototype.buildSet = function () {
        if (this.opts.isServer) {
            return exports.NG_POLY_SERVER;
        }
        else {
            return exports.NG_POLY_BROWSER;
        }
    };
    return NgPolyfillPluginClass;
}());
exports.NgPolyfillPluginClass = NgPolyfillPluginClass;
exports.NgPolyfillPlugin = function (options) { return new NgPolyfillPluginClass(options); };
