"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
exports.__esModule = true;
var defaults = {
    enabled: true
};
var NgProdPluginClass = /** @class */ (function () {
    function NgProdPluginClass(opts) {
        if (opts === void 0) { opts = defaults; }
        this.opts = opts;
        this.test = this.regex || /(app.browser.module.ts)/;
        this.opts = __assign({}, defaults, opts);
    }
    Object.defineProperty(NgProdPluginClass.prototype, "regex", {
        get: function () {
            return this.opts &&
                this.opts.fileTest &&
                new RegExp(this.opts.fileTest) || undefined;
        },
        enumerable: true,
        configurable: true
    });
    NgProdPluginClass.prototype.onTypescriptTransform = function (file) {
        if (!this.opts.enabled || !this.test.test(file.relativePath))
            return;
        file.contents = "import { enableProdMode } from '@angular/core';\n    enableProdMode()\n    " + file.contents;
    };
    return NgProdPluginClass;
}());
exports.NgProdPluginClass = NgProdPluginClass;
exports.NgProdPlugin = function (options) { return new NgProdPluginClass(options); };
