"use strict";
exports.__esModule = true;
var NgServerModulePluginClass = /** @class */ (function () {
    function NgServerModulePluginClass(opts) {
        this.opts = opts;
        this.test = /server.app.ts/;
    }
    NgServerModulePluginClass.prototype.onTypescriptTransform = function (file) {
        if (!file.relativePath.includes('server.app.ts'))
            return;
        var d = RegExp(/declare const AppServerModule: any/);
        var dotCountToAdd = file.relativePath.split('/').length - 1;
        var c = Array.from(Array(dotCountToAdd)).map(function (a) { return '..'; }).join('/');
        file.contents = file.contents.replace(d, "import { " + this.opts.module + " } from '" + c.concat('/') + this.opts.path + "'");
    };
    return NgServerModulePluginClass;
}());
exports.NgServerModulePluginClass = NgServerModulePluginClass;
exports.NgServerModulePlugin = function (options) {
    return new NgServerModulePluginClass(options);
};
