import { Plugin, File } from 'fuse-box'

export interface NgServerModulePluginOptions {
  module: string,
  path: string
}

export class NgServerModulePluginClass implements Plugin {
  constructor(private opts: NgServerModulePluginOptions) { }

  public test = /server.app.ts/

  onTypescriptTransform?(file: File) {
    if(!file.relativePath.includes('server.app.ts')) return
    const d = RegExp(/declare const AppServerModule: any/)
    const dotCountToAdd = file.relativePath.split('/').length - 1
    const c = Array.from(Array(dotCountToAdd)).map(a => '..').join('/')
    file.contents = file.contents.replace(d, 
      `import { ${this.opts.module} } from \'${c.concat('/')}${this.opts.path}\'`)
  }
}

export const NgServerModulePlugin = (options: NgServerModulePluginOptions) =>
  new NgServerModulePluginClass(options);
